package sun.reflect;

import java.lang.reflect.Field;

class UnsafeQualifiedFloatFieldAccessorImpl extends UnsafeQualifiedFieldAccessorImpl
{
    UnsafeQualifiedFloatFieldAccessorImpl(Field field, boolean b) {
        super(field, b);
    }
    
    @Override
    public Object get(Object o) throws IllegalArgumentException {
        return new Float(this.getFloat(o));
    }
    
    @Override
    public boolean getBoolean(Object o) throws IllegalArgumentException {
        throw this.newGetBooleanIllegalArgumentException();
    }
    
    @Override
    public byte getByte(Object o) throws IllegalArgumentException {
        throw this.newGetByteIllegalArgumentException();
    }
    
    @Override
    public char getChar(Object o) throws IllegalArgumentException {
        throw this.newGetCharIllegalArgumentException();
    }
    
    @Override
    public short getShort(Object o) throws IllegalArgumentException {
        throw this.newGetShortIllegalArgumentException();
    }
    
    @Override
    public int getInt(Object o) throws IllegalArgumentException {
        throw this.newGetIntIllegalArgumentException();
    }
    
    @Override
    public long getLong(Object o) throws IllegalArgumentException {
        throw this.newGetLongIllegalArgumentException();
    }
    
    @Override
    public float getFloat(Object o) throws IllegalArgumentException {
        this.ensureObj(o);
        return UnsafeQualifiedFloatFieldAccessorImpl.unsafe.getFloatVolatile(o, this.fieldOffset);
    }
    
    @Override
    public double getDouble(Object o) throws IllegalArgumentException {
        return (double)this.getFloat(o);
    }
    
    @Override
    public void set(Object o, Object o2) throws IllegalArgumentException, IllegalAccessException {
        this.ensureObj(o);
        if (this.isReadOnly) {
            this.throwFinalFieldIllegalAccessException(o2);
        }
        if (o2 == null) {
            this.throwSetIllegalArgumentException(o2);
        }
        if ((o2 instanceof Byte)) {
            UnsafeQualifiedFloatFieldAccessorImpl.unsafe.putFloatVolatile(o, this.fieldOffset, (float)(byte)o2);
            return;
        }
        if ((o2 instanceof Short)) {
            UnsafeQualifiedFloatFieldAccessorImpl.unsafe.putFloatVolatile(o, this.fieldOffset, (float)(short)o2);
            return;
        }
        if ((o2 instanceof Character)) {
            UnsafeQualifiedFloatFieldAccessorImpl.unsafe.putFloatVolatile(o, this.fieldOffset, (float)(char)o2);
            return;
        }
        if ((o2 instanceof Integer)) {
            UnsafeQualifiedFloatFieldAccessorImpl.unsafe.putFloatVolatile(o, this.fieldOffset, (float)(int)o2);
            return;
        }
        if ((o2 instanceof Long)) {
            UnsafeQualifiedFloatFieldAccessorImpl.unsafe.putFloatVolatile(o, this.fieldOffset, (float)(long)o2);
            return;
        }
        if ((o2 instanceof Float)) {
            UnsafeQualifiedFloatFieldAccessorImpl.unsafe.putFloatVolatile(o, this.fieldOffset, (float)o2);
            return;
        }
        this.throwSetIllegalArgumentException(o2);
        return;
    }
    
    @Override
    public void setBoolean(Object o, boolean b) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(b);
    }
    
    @Override
    public void setByte(Object o, byte b) throws IllegalArgumentException, IllegalAccessException {
        this.setFloat(o, (float)b);
    }
    
    @Override
    public void setChar(Object o, char c) throws IllegalArgumentException, IllegalAccessException {
        this.setFloat(o, (float)c);
    }
    
    @Override
    public void setShort(Object o, short n) throws IllegalArgumentException, IllegalAccessException {
        this.setFloat(o, (float)n);
    }
    
    @Override
    public void setInt(Object o, int n) throws IllegalArgumentException, IllegalAccessException {
        this.setFloat(o, (float)n);
    }
    
    @Override
    public void setLong(Object o, long n) throws IllegalArgumentException, IllegalAccessException {
        this.setFloat(o, (float)n);
    }
    
    @Override
    public void setFloat(Object o, float x) throws IllegalArgumentException, IllegalAccessException {
        this.ensureObj(o);
        if (this.isReadOnly) {
            this.throwFinalFieldIllegalAccessException(x);
        }
        UnsafeQualifiedFloatFieldAccessorImpl.unsafe.putFloatVolatile(o, this.fieldOffset, x);
    }
    
    @Override
    public void setDouble(Object o, double n) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(n);
    }
}
